#ifndef GUIOBJECT_H
#define GUIOBJECT_H
//--------------------------------------------------------------------------------------
#include <qwidget.h>
#include <qpixmap.h>
//--------------------------------------------------------------------------------------
//class QTimer;
//class KTTConsole;
//struct UGOProperty;
//struct UGOElement;
class GUI;
struct GuiProperty
{
	int x;
	int y;
	int width;
	int height;
	QColor backgroundColor;
	QColor textColor;
	int fontSize;
	int type;
};
//--------------------------------------------------------------------------------------

class GuiObject : public QWidget
{
	Q_OBJECT 
public:
	GuiObject(QWidget* parent,GuiProperty* prop,const char* name);
	~GuiObject();
	void changeBackgroundColor(const QColor& color);
	void updateBuffer();
	void setVisualTransact(int k,bool chName=false);
	void setInitName(const QString& newname);
private:
	void paintEvent(QPaintEvent* pevent);
	void mousePressEvent(QMouseEvent* pe);
	void mouseReleaseEvent(QMouseEvent* pe);
	void mouseMoveEvent(QMouseEvent* pe);
	
	void mouseDoubleClickEvent(QMouseEvent* pe);
	
	GuiProperty* Property;
	QPixmap pixBuffer;
	
	bool allowToMove;
	int dX;
	int dY;
	int startX;
	int startY;
	QPoint startPoint;
	bool active;
	QColor initBackgroundColor;
	QString curName;
public slots:
	void slotSetInactive();
	void slotSetActive();
signals:
	void signalKill(GuiObject* ugo);
	void signalDown(GuiObject* ugo);
	void signalFix(GuiObject* ugo);
	void signalPress(GuiObject* ugo);
	void signalRelease(QPoint p1,QPoint p2);
};

#endif
