#include <qtextedit.h>
#include "siedevice.h"
//----------------------------------------------------------
#include "sietransact.h"
#include "guiobject.h"
//----------------------------------------------------------

sieDevice::sieDevice(QObject* parent,const char* name,int delay,int disp) :
 			sieObject(parent,name,SIE_DEVICE),
			delayTime(delay),dispTime(disp)
{
}

//----------------------------------------------------------

sieDevice::~sieDevice()
{
//	qDebug("%s: ~sieDevice",name());
}

//----------------------------------------------------------

void sieDevice::tic(int time)
{
	currentTime=time;
	if(transact)
	{
	
//		qDebug("%d	%s: tic  	%d",time,name(),transact->localTime);
		--transact->localTime;
		if(transact->localTime<0)
		{
			if(!destinations) return;
//			printf("%d    %s: send transact to %s\n",time,name(),destinations->obj->name());
			
			
			strncpy(transact->source,name(),NAMESIZE);
				
			ObjectsList* p=destinations;
			bool fl=false;
			while(p)
			{
				if(p->obj->interchange(transact))
					fl=true;
				p=p->next;
			}

			if(fl) 
			{
				transact=0;
				if(guiObj) guiObj->setVisualTransact(0);

			}
		}
		statBusyTime++;
	}
	else
		statFreeTime++;

}

//----------------------------------------------------------
//----------------------------------------------------------


bool sieDevice::interchange(sieTransact* tr)
{
	if(transact)
	{
		printf("%d    %s doesn't receive transact\n",currentTime,name());
		output->append(QString("%1    %2     ()").arg(currentTime).arg(name()));
		return false;
	}
	
	if(guiObj) guiObj->setVisualTransact(1);
	
	printf("%d    %s: receive transact\n",currentTime,name());
	output->append(QString("%1    %2  ").arg(currentTime).arg(name()));
	statTransactNum++;
	tr->localTime=delayTime;
	if(dispTime>0) tr->localTime+=(rand() % (dispTime*2+1)) - dispTime;
	//printf("\t\tnext delay=%d\n",tr->localTime);
	transact=tr;
	return true;
}

//----------------------------------------------------------

void sieDevice::init()
{
	transact=0;
	if(guiObj) guiObj->setVisualTransact(0);
}
