#include <qtextedit.h>
#include "siegenerator.h"
//----------------------------------------------------------
#include "sietransact.h"
#include "sietransactlist.h"
#include "guiobject.h"

//----------------------------------------------------------

sieGenerator::sieGenerator(QObject* parent,const char* name,sieTransactList* trList,
				int tgen,int disp,int num) :
 				sieObject(parent,name,SIE_GENERATOR),
				genNumInit(num),/*genType(type),*/transactList(trList),
				delayTime(tgen),dispTime(disp)

{
//	printf("%s: sieGenerator %d %d %d\n",name,tgen,disp,num);

	tdel=delayTime;
	if(disp>0) tdel+=(rand() % (disp*2+1)) - disp;
	if(genNumInit<0) genNumInit=0x7FFFFFFF;
	transact=new sieTransact;
}

void sieGenerator::init()
{
	genNum=genNumInit;
	tdel=delayTime;
	if(dispTime>0) tdel+=(rand() % (dispTime*2+1)) - dispTime;
}

//----------------------------------------------------------

sieGenerator::~sieGenerator()
{
	delete transact;
	transact=0;
//	qDebug("%s: ~sieGenerator",name());
}


void sieGenerator::tic0(int time)
{
	currentTime=time;
	if(guiObj) guiObj->setVisualTransact(0);
}


//----------------------------------------------------------

void sieGenerator::tic(int time)
{
	if(genNum>0)
	{
		tdel--;
		if(tdel<=0)
		{
			if(!destinations) return;
			sieTransact* tr=transactList->create();
			*tr=*transact;
			tr->initTime=time;
			//tr->lifeLimit=transactLifeLimit;
			tr->lifeLimit+=(rand() % (transactLifeLimitDisp*2+1)) - transactLifeLimitDisp;
			//tr->cost=transactCost;
			tr->cost+=(rand() % int(transactCostDisp*2+1)) - transactCostDisp;
			
			//tr->type=genType;
			printf("%d    %s: create transact\n",time,name());
			output->append(QString("%1    %2   ").arg(time).arg(name()));
			tdel=delayTime;
			if(dispTime>0) tdel+=(rand() % (dispTime*2+1)) - dispTime;
			bool fl=sendTransact(tr);
			
			if(fl)
			{
				if(guiObj) guiObj->setVisualTransact(1);

				statTransactNum++;

				//				emit signalNewTransact();
				genNum--;
			
//			qDebug("%s: genNum=%d",name(),genNum);	
				if(genNum==0) emit signalGeneratorEmpty();
			}
			else
			{
				qDebug("!!!");
				transactList->remove(tr);
			}
		}

	}
}

//----------------------------------------------------------

void sieGenerator::setTransactProperty(sieTransact* tr,int trLLD,double trCD)
{
	if(tr) qDebug("prop type=%d",tr->type);
	if(tr) *transact=*tr;
	if(trLLD>=0) transactLifeLimitDisp=trLLD;
	if(trCD>=0) transactCostDisp=trCD;
}

int sieGenerator::transactType() 
{
	return transact->type;
}


void sieGenerator::setGenerationType(int k) 
{
	transact->type=k;
}

int sieGenerator::lifeLimit() 
{
	return transact->lifeLimit;
};

double sieGenerator::cost() 
{
	return transact->cost;
};

bool sieGenerator::interchange(sieTransact* tr)
{
	return sendTransact(tr);
}

bool sieGenerator::sendTransact(sieTransact* tr)
{
	strncpy(tr->source,name(),NAMESIZE);
			//printf("\t\tnext transact after %d tu\n",tdel);
	tr->initTime=currentTime;
		
				
	ObjectsList* p=destinations;
	bool fl=false;
	while(p)
	{
//				if(emit signalSend(p->name,tr))
//					fl=true;
		if(p->obj->interchange(tr))
			fl=true;
		p=p->next;
	}
	return fl;
}
