#ifndef SIEINITPARSER_H
#define SIEINITPARSER_H

//--------------------------------------------------------------------------
#include <qxml.h>
#include "sietypes.h"
#include "sietransact.h"
//--------------------------------------------------------------------------
class StructModule;
class GUI;
class sieObject;
class QTextEdit;
//--------------------------------------------------------------------------

struct Init
{
	struct
	{
		int x;
		int y;
		int type;
		char name[NAMESIZE];
		sieObject* obj;
	} currentObject;
	sieTransact transact;
	int trLLD;
	double trCD;
};

struct connectionList
{
	char obj1[NAMESIZE];
	char obj2[NAMESIZE];
	int type;
	int probability;
};
//--------------------------------------------------------------------------

class sieInitParser : public QXmlDefaultHandler
{
public:
	sieInitParser(StructModule* mod,GUI* canv,QTextEdit* out);
	~sieInitParser();
	bool startElement(const QString &namespaceURI,
			const QString &localName,
			const QString &qName,
			const QXmlAttributes &attrib);
	bool endElement(const QString &namespaceURI,
			const QString &localName,
			const QString &qName);
	bool characters(const QString &str);
	bool fatalError(const QXmlParseException &exception);
	QString errorString();
	
	bool parseObject(int type,const QXmlAttributes &attrib);
	bool parseTransact(const QXmlAttributes &attrib);
	bool parseGui(const QXmlAttributes &attrib);
	bool parseConnection(const QXmlAttributes &attrib);
	bool parseModel(const QXmlAttributes &attrib);
private:
	StructModule* module;
	GUI* canvas;
	int conNum;
	QString errStr;
	Init init;
	connectionList conList[50];
	QTextEdit* output;
};

//--------------------------------------------------------------------------

#endif
