#ifndef SIEOBJECT_H
#define SIEOBJECT_H
//----------------------------------------------------------
#include <qobject.h>
#include "sietypes.h"
//----------------------------------------------------------
class QTextEdit;
struct sieTransact;
struct sieStatistic;
class sieObject;
class GuiObject;

struct ObjectsList
{
	bool already;
	int type;
	int probability;
	sieObject* obj;
	ObjectsList* next;
};
//----------------------------------------------------------

class sieObject : public QObject
{
	Q_OBJECT
public:
	sieObject(QObject* parent,const char* name,int tp=-1);
	~sieObject();
	void setCoordinates(int x,int y) {qDebug("x=%d y=%d",x,y);X=x;Y=y;}
	int x() {return X;}
	int y() {return Y;}
	virtual void init();
	virtual void tic(int time=0)=0;
	virtual void tic0(int time);
	void getStatistic(sieStatistic* stat);
	void clearStatistic();
	void addDestination(sieObject* obj,int tp,int probability=-1);
	void addSource(sieObject* obj,int tp);
//	virtual bool isReady(int type) {type=type; return true;}
	virtual bool interchange(sieTransact*);
	int objectType() {return objecttype;}
	ObjectsList* destination() {return destinations;}
	
	void setOutput(QTextEdit* out) {output=out;}
	void setGui(GuiObject* obj);
	void setVisual(bool isVis);

	
protected:
	
	sieTransact* transact;
	int objecttype;
	int currentTime;
//	bool isReceiverReady;
	int statTransactNum;
	int statBusyTime;
	int statFreeTime;
	int statAge;
	int statTransactMaxNum;
	double statSumCost;
	//bool isReady;
	ObjectsList* destinations;
	ObjectsList* sources;
	
	int X;
	int Y;
	GuiObject* guiObj;
	GuiObject* initGuiObject;
	
	QTextEdit* output;
	
};

//----------------------------------------------------------

#endif
