#include <qtextedit.h>
#include "sieterminator.h"
//----------------------------------------------------------
#include "sietransact.h"
#include "sietransactlist.h"
//----------------------------------------------------------

sieTerminator::sieTerminator(QObject* parent,const char* name,sieTransactList* trList,int numdec) : 
				sieObject(parent,name,SIE_TERMINATOR),
				numDec(numdec),transactList(trList)
{
//	qDebug("%s: numDec=%d",name,numDec);
	
}

//----------------------------------------------------------

sieTerminator::~sieTerminator()
{
//	qDebug("%s: ~sieTerminator",name());	
}

//----------------------------------------------------------

//----------------------------------------------------------

bool sieTerminator::interchange(sieTransact* tr)
{
	printf("%d    %s : terminate transact\n",currentTime,name());
	output->append(QString("%1    %2  ").arg(currentTime).arg(name()));
	statTransactNum++;
	//qDebug("initTime=%d currentTime=%d",tr->initTime,currentTime);
	statAge+=currentTime-tr->initTime+1;
	statSumCost+=tr->cost;
	transactList->remove(tr);
//	emit signalTerminate();
	if(numDec>0)
	{
//		printf("numdec=%d\n",numDec);
		for(int i=0;i<numDec;i++)
			emit signalDecLife();
	}
	return true;
}


//----------------------------------------------------------

void sieTerminator::tic(int time)
{
	currentTime=time;
}

//----------------------------------------------------------
