#include <qtextedit.h>
#include "sieunpacker.h"
//----------------------------------------------------------
#include "sietransact.h"
#include "sietransactlist.h"
#include "guiobject.h"
//----------------------------------------------------------

sieUnpacker::sieUnpacker(QObject* parent,const char* name,sieTransactList* trList,int tp) :
 			sieObject(parent,name,SIE_UNPACKER),
			transactList(trList),type(tp)
{
}

//----------------------------------------------------------

sieUnpacker::~sieUnpacker()
{
	qDebug("%s: ~sieUnpacker",name());
}

//----------------------------------------------------------
void sieUnpacker::init()
{
	ObjectsList* ps=destinations;
	while(ps)
	{
		ps->already=true;
		ps=ps->next;
	}
}

void sieUnpacker::tic(int time)
{
	currentTime=time;
	if(transact)
	{
		statBusyTime++;
		ObjectsList* p=destinations;
		bool fl=true;
		while(p)
		{
			if(!p->already)
			{
				//if(p->obj->isReady(p->type))
				
					sieTransact* tr=transactList->create();
					tr->type=p->type;
					strncpy(tr->source,name(),NAMESIZE);
				
					if(p->obj->interchange(tr))
						p->already=true;
					else
					{
						transactList->remove(tr);
						fl=false;
					}
			}
			p=p->next;
		}
		if(fl)
		{

			transactList->remove(transact);
			transact=0;
			if(guiObj) guiObj->setVisualTransact(0);
		}
	}
	else
		statFreeTime++;
}

//----------------------------------------------------------

bool sieUnpacker::interchange(sieTransact* tr)
{
	if(tr->type!=type) return false;
	if(transact)
	{
		printf("%d    %s: doesn't receive transact\n",currentTime,name());
		output->append(QString("%1    %2: doesn't receive transact").arg(currentTime).arg(name()));
		return false ;
	}
	
	if(guiObj) guiObj->setVisualTransact(1);

	printf("%d    %s: receive transact\n",currentTime,name());
	output->append(QString("%1    %2: receive transact").arg(currentTime).arg(name()));
	statTransactNum++;
	transact=tr;
	ObjectsList* p=destinations;
	while(p)
	{
		p->already=false;
		p=p->next;
	}
	return true;
}

//----------------------------------------------------------

